Metaprogramming
Utilities
Collaboration diagram for Metaprogramming:

## Classes

struct | std::__is_nullptr_t< _Tp >
struct | std::integral_constant< _Tp, __v >
struct | std::is_abstract< _Tp >
struct | std::is_arithmetic< _Tp >
struct | std::is_array< typename >
struct | std::is_class< _Tp >
struct | std::is_compound< _Tp >
struct | std::is_const< typename >
struct | std::is_empty< _Tp >
struct | std::is_enum< _Tp >
struct | std::is_floating_point< _Tp >
struct | std::is_function< typename >
struct | std::is_fundamental< _Tp >
struct | std::is_integral< _Tp >
struct | std::is_literal_type< _Tp >
struct | std::is_lvalue_reference< typename >
struct | std::is_member_function_pointer< _Tp >
struct | std::is_member_object_pointer< _Tp >
struct | std::is_member_pointer< typename >
struct | std::is_null_pointer< _Tp >
struct | std::is_object< _Tp >
struct | std::is_pod< _Tp >
struct | std::is_pointer< _Tp >
struct | std::is_polymorphic< _Tp >
struct | std::is_reference< _Tp >
struct | std::is_rvalue_reference< typename >
struct | std::is_scalar< _Tp >
struct | std::is_standard_layout< _Tp >
struct | std::is_trivial< _Tp >
struct | std::is_union< _Tp >
struct | std::is_void< _Tp >
struct | std::is_volatile< typename >
struct | std::tr2::__reflection_typelist< _Elements >
struct | std::tr2::__reflection_typelist< _First, _Rest...>
struct | std::tr2::__reflection_typelist<>
struct | std::tr2::bases< _Tp >
struct | std::tr2::direct_bases< _Tp >

## Typedefs

typedef integral_constant < bool, false > | std::false_type
typedef integral_constant < bool, true > | std::true_type
typedef integral_constant< _Tp, __v > | std::integral_constant< _Tp, __v >::type
typedef _Tp | std::__success_type< _Tp >::type
typedef _Tp | std::integral_constant< _Tp, __v >::value_type

## Functions

constexpr | std::integral_constant< _Tp, __v >::operator value_type () const

## Variables

static constexpr _Tp | std::integral_constant< _Tp, __v >::value

## Detailed Description

Template utilities for compile-time introspection and modification, including type classification traits, type property inspection traits and type transformation traits.

## Typedef Documentation

typedef integral_constant<bool, false> std::false_type

The type used as a compile-time boolean with false value.

Definition at line 75 of file type_traits.

typedef integral_constant<bool, true> std::true_type

The type used as a compile-time boolean with true value.

Definition at line 72 of file type_traits.